/////////////////////////////////////////////////////////////////////////////
//
//	Modified by Claybird <claybird.without.wing@gmail.com>
//
// MenuExtension.cpp :	gVF ReNXgj[R|[lgNX̒`
//						LhaForgegj[
//
//	Original File Information:
// MenuExtension.cpp :	gVF ReNXgj[R|[lgNX̒`
//						l(TF)gj[
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MenuData.h"
#include "MenuExtension.h"
#include "Main.h"
#include "resource.h"
#include "lfutil.h"

//-------------------------------------------------------------------------
// CMenuExtension	RXgN^EfXgN^
//-------------------------------------------------------------------------

// CMenuExtension
CMenuExtension::CMenuExtension(bool bRightDrag)
	:	m_cRef(0L),
		m_bRightDrag(bRightDrag),
		m_bForceExtraMenu(GetKeyState(VK_SHIFT)<0)	//SHIFTĂƂgj[[h
{
	InterlockedIncrement(&g_cDllRef);
	dprintf(_T("\n\nCMenuExtension::CMenuExtension\n"));
}

// ~CMenuExtension
CMenuExtension::~CMenuExtension()
{
	dprintf(_T("CMenuExtension::~CMenuExtension\n\n\n"));

	//j[f[^̔j
	DeleteMenuData();

	InterlockedDecrement(&g_cDllRef);
}

//-------------------------------------------------------------------------
// CMenuExtension	
//
//			IUnknown C^[tFCX̃\bhQ
//
//				QueryInterface
//				AddRef
//				Release
//
//-------------------------------------------------------------------------

// QueryInterface
STDMETHODIMP CMenuExtension::QueryInterface(
	REFIID		riid,
	LPVOID *	ppv)
{
	dprintf(_T("CMenuExtension::QueryInterface(ppvObj=%x , riid=%d)\n"),ppv,riid);

	*ppv = NULL;
	if(IsEqualIID(riid, IID_IShellExtInit) || IsEqualIID(riid, IID_IUnknown)){
		*ppv = (LPSHELLEXTINIT)this;
	}
	else if(IsEqualIID(riid, IID_IContextMenu)){
		*ppv = (LPCONTEXTMENU)this;
	}

    if(*ppv){
		static_cast<IUnknown*>(*ppv)->AddRef();
		return NOERROR;
	}

	return E_NOINTERFACE;
}

// AddRef
STDMETHODIMP_(ULONG) CMenuExtension::AddRef()
{
	dprintf(_T("CMenuExtension::AddRef (m_cRef=%d)\n"),m_cRef);

	InterlockedIncrement(&m_cRef);
	return m_cRef;
}

// Release
STDMETHODIMP_(ULONG) CMenuExtension::Release()
{
	dprintf(_T("CMenuExtension::Release (m_cRef=%d)\n"),m_cRef);

	ULONG theRef = InterlockedDecrement(&m_cRef);
	if(theRef == 0L)delete this;
	return theRef;	// [JϐgĂ̂ delete łlԂ悤
}

//-------------------------------------------------------------------------
// CMenuExtension	
//
//			IShellExtInit C^[tFCX̃\bh
//
//				Initialize
//
//-------------------------------------------------------------------------

// Initialize
STDMETHODIMP CMenuExtension::Initialize(
	LPCITEMIDLIST	pIDFolder,
	LPDATAOBJECT	pDataObj,
	HKEY			hRegKey)
{
	dprintf(_T("CMenuExtension::Initialize\n"));

	UNREFERENCED_PARAMETER(hRegKey);

	m_SelFileArray.clear();

	//j[f[^̔j
	DeleteMenuData();

	//ΏۃtH_擾
	if(m_bRightDrag){
		TCHAR Buffer[_MAX_PATH+3]={0};
		::SHGetPathFromIDList( pIDFolder, Buffer);
		PathQuoteSpaces(Buffer);
		m_strTargetFolder=Buffer;
	}

	//It@C擾
    if(pDataObj){
		GetSelectedFiles(pDataObj);
    }

	// j[̏
	PrepareMenu();
	return NOERROR;
}

//-------------------------------------------------------------------------
// CMenuExtension	
//
//			IShellExtInit C^[tFCX̃\bhQ
//
//				QueryContextMenu
//				InvokeCommand
//				GetCommandString
//
//-------------------------------------------------------------------------

// QueryContextMenu
STDMETHODIMP CMenuExtension::QueryContextMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst,
	UINT	idCmdLast,
	UINT	uFlags)
{
	dprintf(_T("CMenuExtension::QueryContextMenu\n"));

	// uFlags  CMF_DEFAULTONLY ܂܂ꍇ͉Ȃ
	if (uFlags & CMF_DEFAULTONLY){
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	if((uFlags&0x000F)!=CMF_NORMAL && !(uFlags&CMF_VERBSONLY) && !(uFlags&CMF_EXPLORE)/*c[r[ŉENbN*/){
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	//t@CIĂȂȂ牽Ȃ
	if(m_SelFileArray.empty()){
		return MAKE_HRESULT(SEVERITY_SUCCESS,FACILITY_NULL,0);
	}

	//================
	// j[̕\
	//================
	HMENU hTargetMenu=hMenu;
	UINT subMenuIdx=indexMenu;
	if(m_Config.bUnderSubMenu){	//Tuj[ȉɕ荞ޏꍇ
		hTargetMenu=MakePopupMenuItem();
		subMenuIdx=0;
	}
	//ۂɃj[ǉ
	UINT itemsAdded=InsertContextMenu(hTargetMenu,subMenuIdx,idCmdFirst,m_Config.bUnderSubMenu);

	//̃j[ǉꍇ
	if(itemsAdded!=0){
		int nTop=itemsAdded;
		if(m_Config.bUnderSubMenu){	//Tuj[
			//uLhaForgevǉ
			CString strCaption;
			UtilLoadString(IDS_MENU_CAPTION_LHAFORGE,strCaption);
			UtilInsertMenuItem(hMenu,strCaption,indexMenu+itemsAdded,hTargetMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
			AddDummyMenuCommand();

			nTop=1;
		}

		//------------------------
		// Ō̃Zp[^̒ǉ
		//------------------------
		UtilInsertMenuItem(hMenu,NULL,indexMenu+nTop,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());
		AddDummyMenuCommand();
	}

	/*
	 * From MSDN:
	 * If successful, returns an HRESULT value that has its severity value set to SEVERITY_SUCCESS and its code value
	 * set to the offset of the largest command identifier that was assigned, plus one.
	 * 
	 * For example, assume that idCmdFirst is set to 5 and you add three items to the menu with
	 * command identifiers of 5, 7, and 8.
	 * 
	 * The return value should be MAKE_HRESULT(SEVERITY_SUCCESS, 0, 8 - 5 + 1). Otherwise, it returns an OLE error value.
	 */
	return MAKE_HRESULT(SEVERITY_SUCCESS, FACILITY_NULL,(WORD)m_CmdParamArray.size());
}

HMENU CMenuExtension::MakePopupMenuItem()
{
	HMENU hTempMenu=::CreatePopupMenu();
	m_MenuHandleList.push_back(hTempMenu);
	return hTempMenu;
}

void CMenuExtension::BuildExtraMenu(HMENU hParentMenu,UINT idCmdFirst,int menuIdx,const SHELL_MENU_ITEM* pMenu,size_t numItems)
{
	//|bvAbvj[̍{
	HMENU hTempMenu=MakePopupMenuItem();
	CString strCaption;
	UtilLoadString(pMenu[0].Caption,strCaption);
	UtilInsertMenuItem(hParentMenu,strCaption,menuIdx,hTempMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
	//_~[ACe
	AddDummyMenuCommand();

	//ej[
	InsertCommandMenuItems(hTempMenu,idCmdFirst,pMenu+1,numItems-1,0);
}

void CMenuExtension::InsertCommandMenuItems(HMENU hParentMenu,UINT idCmdFirst,const SHELL_MENU_ITEM* pMenu,size_t numItems,int nOffset)
{
	for(UINT idx=0;idx<numItems;idx++){
		CString strCaption;
		UtilLoadString(pMenu[idx].Caption,strCaption);

		UtilInsertMenuItem(hParentMenu,strCaption,idx+nOffset,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

		m_CmdParamArray.push_back(pMenu[idx].Param);
	}
}

UINT CMenuExtension::InsertCompressMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	//---kj[
	HMENU hCompressSubMenu=MakePopupMenuItem();

	bool bMenuAdded=false;

	if(m_Config.bExtraMenu){
		//Wj[
		for(int menuIdx=0;menuIdx<COUNTOF(g_ExtraMenuTable);menuIdx++){
			BuildExtraMenu(hCompressSubMenu,idCmdFirst,menuIdx,g_ExtraMenuTable[menuIdx].pMenu,g_ExtraMenuTable[menuIdx].numItems);
		}
		bMenuAdded=true;
	}else if(!m_Config.bCustomCompress){
		//ʏ̈kj[
		InsertCommandMenuItems(hCompressSubMenu,idCmdFirst,g_CompressMenu,COUNTOF(g_CompressMenu),0);
		bMenuAdded=true;
	}else{
		//JX^}CYꂽj[g
		std::vector<SHELL_MENU_ITEM> menu;

		LPCTSTR lpChar=m_Config.szCustomCompress;
		dprintf(_T("CustomMenu Arrange Data=%s\n"),lpChar);
		for(;*lpChar!=_T('\0');lpChar++){
			int i;
			for(i=0;i<COUNTOF(g_UserMenuTable);i++){
				if(g_UserMenuTable[i].Identifier==*lpChar){	//v
					break;
				}
			}
			if(i==COUNTOF(g_UserMenuTable)){	//v镨ȂA܂sȃj[w
				MessageBeep(MB_ICONEXCLAMATION);
				continue;
			}else{
				//j[ACeǉ
				SHELL_MENU_ITEM smi;
				smi.Caption=g_UserMenuTable[i].lpMenuItem->Caption;
				smi.Param=g_UserMenuTable[i].lpMenuItem->Param;
				menu.push_back(smi);
			}
		}

		if(!menu.empty()){
			InsertCommandMenuItems(hCompressSubMenu,idCmdFirst,&menu[0],menu.size(),0);
			bMenuAdded=true;
		}
	}


	if(bMenuAdded){
		//kj[̃|bvAbv̍{ǉ
		CString strCaption;
		if(m_bRightDrag){	//EhbO
			UtilLoadString(IDS_MENU_CAPTION_COMPRESS_DRAG,strCaption);
		}else{	//ENbN
			UtilLoadString(IDS_MENU_CAPTION_COMPRESS,strCaption);
		}
		dprintf(_T("MenuCaption=(%s),indexMenu=(%d)\n"),(LPCTSTR)strCaption,m_CmdParamArray.size());
		UtilInsertMenuItem(hMenu,strCaption,indexMenu,hCompressSubMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
		AddDummyMenuCommand();
		return 1;
	}else{
		return 0;
	}
}


UINT CMenuExtension::InsertExtractMenuRClick(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	HMENU hExtractSubMenu=MakePopupMenuItem();

	//ENbNj[ŉ𓀂\KvƂ
	CString strCaption;
	//uLhaForgeŉ𓀁vǉ
	UtilLoadString(IDS_MENU_CAPTION_EXTRACT,strCaption);
	dprintf(_T("MenuCaption=(%s),indexMenu=(%d)\n"),(LPCTSTR)strCaption,indexMenu);
	UtilInsertMenuItem(hMenu,strCaption,indexMenu,hExtractSubMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
	AddDummyMenuCommand();

	// R}hp^ǉƂȂTuj[R}hǉ
	InsertCommandMenuItems(hExtractSubMenu,idCmdFirst,g_ExtractMenu,COUNTOF(g_ExtractMenu),0);

	return 1;
}

UINT CMenuExtension::InsertExtractMenuRDrag(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	CString strCaption;
	UtilLoadString(IDS_MENU_CAPTION_EXTRACT_DRAG,strCaption);

	UtilInsertMenuItem(hMenu,strCaption,indexMenu,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

	m_CmdParamArray.push_back(_T("/e"));
	return 1;
}

UINT CMenuExtension::InsertOperationMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	// {j[
	UINT subIndex=0;
	if(m_Config.ShellMenu.bList){
		//ENbNj[̏ꍇ̂
		CString strCaption;
		UtilLoadString(IDS_MENU_CAPTION_LIST,strCaption);
		UtilInsertMenuItem(hMenu,strCaption,indexMenu+subIndex,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

		m_CmdParamArray.push_back(_T("/l"));
		subIndex++;
	}

	// j[
	if(m_Config.ShellMenu.bTestArchive){
		CString strCaption;
		UtilLoadString(IDS_MENU_CAPTION_TEST_ARCHIVE,strCaption);
		UtilInsertMenuItem(hMenu,strCaption,indexMenu+subIndex,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

		m_CmdParamArray.push_back(_T("/t"));
		subIndex++;
	}

	return subIndex;
}

UINT CMenuExtension::InsertXacRettMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	if(!m_bRightDrag){	//ENbNj[̏ꍇ
		HMENU hXacRettSubMenu=MakePopupMenuItem();
		//uLhaForge+XacRett.DLLvǉ
		CString strCaption;
		UtilLoadString(IDS_MENU_CAPTION_XACRETT,strCaption);
		UtilInsertMenuItem(hMenu,strCaption,indexMenu,hXacRettSubMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
		AddDummyMenuCommand();

		// R}hp^ǉƂȂTuj[R}hǉ
		InsertCommandMenuItems(hXacRettSubMenu,idCmdFirst,g_XacRettMenu,COUNTOF(g_XacRettMenu),0);
	}else{
		//EhbOj[̏ꍇ
		CString strCaption;
		UtilLoadString(IDS_MENU_CAPTION_XACRETT_DRAG,strCaption);

		UtilInsertMenuItem(hMenu,strCaption,indexMenu,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

		m_CmdParamArray.push_back(_T("/xacrett /e"));
	}
	return 1;
}

UINT CMenuExtension::InsertB2EMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	HMENU hB2ESubMenu=MakePopupMenuItem();

	CString strCaption;
	//uLhaForge+B2E32.DLLvǉ
	UtilLoadString(IDS_MENU_CAPTION_B2E,strCaption);
	UtilInsertMenuItem(hMenu,strCaption,indexMenu,hB2ESubMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
	AddDummyMenuCommand();

	int nOffset=0;
	//k`j[ŕ\ȂTuj[ǉ
	//uB2Eł̌`ɈkvIȓe
	bool bMethodSelect=!m_Config.B2ECompressMenu.empty();
	if(bMethodSelect){
		HMENU hB2ECompressPopup=MakePopupMenuItem();
		UtilLoadString(IDS_MENU_CAPTION_B2E_COMPRESS_POPUP,strCaption);
		UtilInsertMenuItem(hB2ESubMenu,strCaption,0,hB2ECompressPopup,idCmdFirst+(WORD)m_CmdParamArray.size());
		AddDummyMenuCommand();

		//`Ƃ̃j[p
		for(UINT j=0;j<m_Config.B2ECompressMenu.size();j++){
			//`̃j[
			HMENU hTempMenu=MakePopupMenuItem();
			UtilInsertMenuItem(hB2ECompressPopup,m_Config.B2ECompressMenu[j][0],j,hTempMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
			AddDummyMenuCommand();

			for(UINT i=1;i<m_Config.B2ECompressMenu[j].size();i++){
				UtilInsertMenuItem(hTempMenu,m_Config.B2ECompressMenu[j][i],i-1,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());

				CString strParam;
				strParam.Format(_T("/b2e \"/c:%s\" \"/method:%s\" "),(LPCTSTR)m_Config.B2ECompressMenu[j][0],(LPCTSTR)m_Config.B2ECompressMenu[j][i]);
				m_CmdParamArray.push_back(strParam);
			}
		}

		nOffset=1;
	}

	// R}hp^ǉƂȂTuj[R}hǉ
	if(m_bRightDrag){
		InsertCommandMenuItems(hB2ESubMenu,idCmdFirst,g_B2EDragMenu,COUNTOF(g_B2EDragMenu),nOffset);
	}else{
		InsertCommandMenuItems(hB2ESubMenu,idCmdFirst,g_B2EMenu,COUNTOF(g_B2EMenu),nOffset);
	}
	return 1;
}

UINT CMenuExtension::InsertUserMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst)
{
	UINT subIndex=0;
	for(UINT i=0;i<m_Config.UserMenuArray.size();i++){
		// R}hj[ǉ
		UtilInsertMenuItem(hMenu,m_Config.UserMenuArray[i].Caption,indexMenu+subIndex,NULL,idCmdFirst+(WORD)m_CmdParamArray.size());
		m_CmdParamArray.push_back(m_Config.UserMenuArray[i].Param);
		subIndex++;
	}
	return subIndex;
}

UINT CMenuExtension::InsertContextMenu(
	HMENU	hMenu,
	UINT	indexMenu,
	UINT	idCmdFirst,
	BOOL	bInSubMenu)
{
	// j[̕\

	UINT subIndex=0;
	//--kj[
	if(m_Config.ShellMenu.bCompress || m_Config.DragMenu.bCompress){
		subIndex+=InsertCompressMenu(hMenu,indexMenu+subIndex,idCmdFirst);
	}

	//--𓀃j[
	if(m_Config.ShellMenu.bExtract){		//ENbN
		subIndex+=InsertExtractMenuRClick(hMenu,indexMenu+subIndex,idCmdFirst);
	}else if(m_Config.DragMenu.bExtract){	//EhbO
		subIndex+=InsertExtractMenuRDrag(hMenu,indexMenu+subIndex,idCmdFirst);
	}

	bool bSub=/*m_bXP && */!bInSubMenu && !m_bRightDrag;
	if(bSub){
		HMENU hOperationMenu=MakePopupMenuItem();
		int subSubIndex=0;
		//--LhaForgeő
		subSubIndex+=InsertOperationMenu(hOperationMenu,subSubIndex,idCmdFirst);
		//--[U[`j[
		subSubIndex+=InsertUserMenu(hOperationMenu,subSubIndex,idCmdFirst);

		if(subSubIndex>0){
			CString strCaption;
			UtilLoadString(IDS_MENU_CAPTION_OPERATION,strCaption);
			UtilInsertMenuItem(hMenu,strCaption,indexMenu+subIndex,hOperationMenu,idCmdFirst+(WORD)m_CmdParamArray.size());
			AddDummyMenuCommand();
			subIndex++;
		}
	}else{
		//--LhaForgeő
		subIndex+=InsertOperationMenu(hMenu,indexMenu+subIndex,idCmdFirst);
	}

	//-- XacRettj[
	if(m_Config.bXacRett){
		subIndex+=InsertXacRettMenu(hMenu,indexMenu+subIndex,idCmdFirst);
	}

	//--B2Ej[
	if(m_Config.bB2E){
		subIndex+=InsertB2EMenu(hMenu,indexMenu+subIndex,idCmdFirst);
	}
	//--[U[`j[
	if(!bSub){
		subIndex+=InsertUserMenu(hMenu,indexMenu+subIndex,idCmdFirst);
	}

	return subIndex;
}

// InvokeCommand
STDMETHODIMP CMenuExtension::InvokeCommand(
	LPCMINVOKECOMMANDINFO	lpcmi)
{
	dprintf(_T("CMenuExtension::InvokeCommand\n"));

	HRESULT hr = E_INVALIDARG;

	// HIWORD(lpcmi->lpVerb)0ł͂ȂƂ̂ݏ
	// LOWORD(lpcmi->lpVerb)̓NbNꂽj[ID
	// QueryContextMenu()ł (menu ID - idCmdFirst)
	if(!HIWORD(lpcmi->lpVerb)){
		UINT idCmd = LOWORD(lpcmi->lpVerb);

		// gj[̗L͈͂`FbN
		if(!m_CmdParamArray.empty() && idCmd >= 0 && idCmd < m_CmdParamArray.size()){
			// R}hs
			DoCommand(idCmd);
			hr = NOERROR;
		}
	}
	return hr;
}

// GetCommandString
STDMETHODIMP CMenuExtension::GetCommandString(
	UINT_PTR	idCmd,
	UINT	uType,
	UINT*	pwReserved,
	LPSTR	pszName,
	UINT cchMax)
{
	UNREFERENCED_PARAMETER(pwReserved);

	dprintf(_T("CMenuExtension::GetCommandString(ParamCount=%d : idCmd=%d)\n"),m_CmdParamArray.size(),idCmd);

	//ID:VXeɂ郁j[ACȇ݊mFs
	//http://blogs.msdn.com/oldnewthing/archive/2004/10/06/238630.aspx
	if(idCmd >= m_CmdParamArray.size()){
		if (uType == GCS_VALIDATEA || uType == GCS_VALIDATEW) {
			return S_FALSE;
		}else return E_INVALIDARG;
	}

	// Xe[^X\
	CString strCaption;
	UtilLoadString(IDS_DEFAULT_STATUS_CAPTION,strCaption);
	switch (uType) {
	case GCS_VERBA:
	case GCS_VERBW:
		return E_NOTIMPL;

	case GCS_HELPTEXTA:
		lstrcpynA(pszName, CT2A(strCaption), cchMax);
		return S_OK;

	case GCS_HELPTEXTW:
		lstrcpynW((LPWSTR)pszName, strCaption, cchMax);
		return S_OK;

	case GCS_VALIDATEA:
	case GCS_VALIDATEW:
		return S_OK;    // all they wanted was validation
	}

	return E_NOTIMPL;
}


//--- VFg@ReNXgj[̎


//IĂt@C̎o
bool CMenuExtension::GetSelectedFiles(LPDATAOBJECT pDataObj)
{
	if(!pDataObj)return false;

	IEnumFORMATETC *theEnumFormatEtc = 0;
	HRESULT thrResultH = pDataObj->EnumFormatEtc(DATADIR_GET, &theEnumFormatEtc);

	if(SUCCEEDED(thrResultH)){
		thrResultH = theEnumFormatEtc->Reset();

		if(SUCCEEDED(thrResultH)){
			FORMATETC theFormatEtc;
			ULONG theFetched = 0L;
			while(TRUE){
				thrResultH = theEnumFormatEtc->Next(1, &theFormatEtc, &theFetched);
				if(FAILED(thrResultH) || (theFetched <= 0)){
					dprintf(__FUNCTIONW__ _T(":End of Data\n"));
					break;
				}
				theFormatEtc.cfFormat	= CF_HDROP;
				theFormatEtc.dwAspect	= DVASPECT_CONTENT;
				theFormatEtc.lindex		= -1;
				theFormatEtc.ptd		= NULL;
				theFormatEtc.tymed		= TYMED_HGLOBAL;
				STGMEDIUM theStgm;
				thrResultH = pDataObj->GetData(&theFormatEtc, &theStgm);
				if(SUCCEEDED(thrResultH)){
					if(theStgm.tymed == TYMED_HGLOBAL){
						UINT nFileCount = DragQueryFile((HDROP)theStgm.hGlobal, 0xFFFFFFFF, NULL, 0);
						if(nFileCount >= 1){
							m_SelFileArray.clear();
							for(UINT i=0; i<nFileCount;i++){
								TCHAR Buffer[_MAX_PATH+2]={0};
								DragQueryFile((HDROP)theStgm.hGlobal, i, Buffer, _MAX_PATH + 1);
								dprintf(__FUNCTIONW__ _T(":%d/%d:%s\n"),i,nFileCount,Buffer);
								m_SelFileArray.push_back(Buffer);
							}
						}
					}
				}
			}
		}
	}
	if(theEnumFormatEtc)theEnumFormatEtc->Release();
	
	return true;
}

/*-------------------------------------------------------------------------*/
//	PrepareMenu		j[̏
/*-------------------------------------------------------------------------*/
void CMenuExtension::PrepareMenu()
{
	//ݒǂݍ
	m_Config.LoadConfig(m_bRightDrag,m_bForceExtraMenu);
}

/*-------------------------------------------------------------------------*/
//	DeleteMenuData			j[f[^̔j
/*-------------------------------------------------------------------------*/
void CMenuExtension::DeleteMenuData()
{
	m_CmdParamArray.clear();
	//Tuj[p
	for(UINT i=0;i<m_MenuHandleList.size();i++){
		::DestroyMenu(m_MenuHandleList[i]);
	}
	m_MenuHandleList.clear();
}

/*-------------------------------------------------------------------------*/
//	DoCommand		Igj[̃t@C`iJj
/*-------------------------------------------------------------------------*/
void CMenuExtension::DoCommand(UINT inIdx)
{
	// R}hIDƃR}hp^̗L̓`FbN

	dprintf(_T("DoCommand-> inIdx=%d : Param=%s\n"),inIdx,(LPCTSTR)m_CmdParamArray[inIdx]);

	// tH_ɂ鈳kvO(LhaForge.exe)̃tpXgݗ
	TCHAR szExePath[_MAX_PATH+1];
	{
		::GetModuleFileName(g_hInstDLL, szExePath, _MAX_PATH);	//DLL̃pX擾
		//DLL̃pXLhaForgẽt@CgݗĂ
		PathRemoveFileSpec(szExePath);

		PathAppend(szExePath, _T("LhaForge.exe"));
		dprintf(_T("ExePath = %s\n"),szExePath);
	}
	CString CommandLine(szExePath);

	//R}hCp[^ݒ
	CommandLine+=_T(" ");
	CommandLine+=m_CmdParamArray[inIdx];	//t@CIvV
	//Ɉk/
	if(m_bRightDrag){
		CommandLine+=_T(" /o:");
		CommandLine+=m_strTargetFolder;//ɕKvȏꍇ""ŊĂ
	}else{
		if(-1!=CommandLine.Find(OUTPUTDIR_DESKTOP)){
			//fXNgbvɉ
			TCHAR Buffer[_MAX_PATH+1]={0};
			SHGetSpecialFolderPath(NULL,Buffer,CSIDL_DESKTOPDIRECTORY,FALSE);
			PathQuoteSpaces(Buffer);
			CommandLine.Replace(OUTPUTDIR_DESKTOP,Buffer);
		}else if(-1!=CommandLine.Find(OUTPUTDIR_SAMEDIR)){
			//ꏊɉ
			CPath strPath(m_SelFileArray[0]);
			strPath.RemoveFileSpec();
			strPath.QuoteSpaces();
			CommandLine.Replace(OUTPUTDIR_SAMEDIR,strPath);
		}else if(-1!=CommandLine.Find(OUTPUTDIR_SPECIFIED)){
			//wꏊɉ
			CString title;
			UtilLoadString(IDS_INPUT_TARGET_FOLDER,title);
			CFolderDialog dlg(NULL,title,BIF_RETURNONLYFSDIRS|BIF_NEWDIALOGSTYLE);
			if(IDOK!=dlg.DoModal()){
				return;
			}
			CPath strPath(dlg.GetFolderPath());
			strPath.QuoteSpaces();
			CommandLine.Replace(OUTPUTDIR_SPECIFIED,strPath);
		}
	}

	//t@CԂɏ
	if(m_SelFileArray.size()>16){
		//t@ĈŃX|Xt@Cg(ɍ)
		TCHAR szTempPath[_MAX_PATH+1];
		{
			TCHAR szTempDir[_MAX_PATH+1];
			::GetTempPath(_MAX_PATH,szTempDir);
			if(!::GetTempFileName(szTempDir,_T("lf"),0,szTempPath)){
				MessageBeep(MB_ICONHAND);
				return;
			}
		}
		HANDLE hFile=::CreateFile(szTempPath,GENERIC_WRITE,0,NULL,CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,NULL);
		if(INVALID_HANDLE_VALUE==hFile){
			MessageBeep(MB_ICONHAND);
			return;
		}
		for(UINT file_count=0;file_count<m_SelFileArray.size();file_count++){
			UtilWriteLine(hFile,m_SelFileArray[file_count]);
		}
		::CloseHandle(hFile);
		//X|Xt@C̎w

#if defined(UNICODE)||defined(_UNICODE)
		//R[hy[Ww
		CommandLine+=_T(" /cp:UNICODE");
#endif

		CommandLine+=_T(" /$\"");
		CommandLine+=szTempPath;
		CommandLine+=_T("\"");
	}else{	//̂܂܃R}hCɓn
		for(UINT file_count=0;file_count<m_SelFileArray.size();file_count++){
			if(-1!=m_SelFileArray[file_count].Find(_T(' '))){
				//PathQuoteSpaces...
				CommandLine+=_T(" \"");
				CommandLine+=m_SelFileArray[file_count];
				CommandLine+=_T("\"");
			}else{
				CommandLine+=_T(" ");
				CommandLine+=m_SelFileArray[file_count];
			}
		}
	}

	// NvZX̕\EBhE̐ݒ
	STARTUPINFO theStartupInfo = {sizeof(STARTUPINFO)};
	theStartupInfo.dwFlags = STARTF_USESHOWWINDOW;
	theStartupInfo.wShowWindow = SW_SHOWDEFAULT;

	// vZXNiR}hsj
	PROCESS_INFORMATION	pi;
	BOOL	result = ::CreateProcess(NULL,CommandLine.GetBuffer(CommandLine.GetLength()+1),
						NULL,NULL,FALSE,CREATE_NEW_PROCESS_GROUP,
						NULL,NULL,&theStartupInfo,&pi);
	CommandLine.ReleaseBuffer();
	dprintf(_T("\tCreateProcess(%s)"),CommandLine);
	dprintf(_T(" result=%s\n"),result ? _T("OK") : _T("NG"));

	if(!result){
		CString Message=szExePath;
		Message+=_T("\n");
		{
			CString msg;
			UtilLoadString(IDS_ERROR_MSG_FAILURE_EXECUTE,msg);
			Message+=msg;
		}

		//G[XgO擾
		{
			TCHAR szBuffer[1024];
			FormatMessage(
				FORMAT_MESSAGE_FROM_SYSTEM|FORMAT_MESSAGE_IGNORE_INSERTS,
				NULL, GetLastError(),
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // ftHg
				szBuffer, 1024, NULL);
			Message+=szBuffer;
		}
		{
			CString title;
			UtilLoadString(IDS_PROGRAM_NAME,title);
			MessageBox(NULL,Message,title,MB_OK|MB_ICONSTOP);
		}
	}

	//svɂȂvZXnh
	CloseHandle(pi.hProcess);
	CloseHandle(pi.hThread);
}


